%{

/* The comments for this file are included into the semantic actions and should be read STARTING FROM THE LAST RULE!!!!
*/

// Directives to the compiler and C declarations
#include <stdio.h>
#define YYERROR_VERBOSE 1

// The lexer
extern int yylex();
extern int yyerror(char *);

%}

// Tokens, given by lexer
%token PLUS
%token PER
%token NUMBER

// Types for tokens and rules
%type <ival> NUMBER
%type <ival> Factor
%type <ival> Term
%type <ival> Expr

// Possible types of yylval
%union {
  int	ival;
}

%%

Eval
  : Expr '='
    { printf("\n%d",$1); 
      YYACCEPT;
    }
  ;

Expr
  : Term PLUS Expr
    { $$ = $1 + $3; }
  | Term
    { $$ = $1;}
  ;

Term
  : Term PER Factor
    { $$ = $1 * $3;
      /* Update tha value of Term, performin the operation. 
         And so on....The policy of value propagation is the same described below..
      */
    }
  | Factor
    { /* The value associated to Factor (that is $1) is associate to Term (that is $$). Let us notice that
         the value that is assigned to Term are given by the rule listed below: in this way we obtain a
         "value propagation", from the leaves to the root of the syntax tree (remember also that the LR
         parsing technique matches first the leaves).
      */
      $$ = $1; 
    }
  ;

Factor
  : '(' Expr ')'
    {  /* The value associated to Expr (that is $1) is assigned to Factor (that is $$) */
       $$ = $2; 
    }
  | NUMBER
    { /* The value associated to NUMBER (that is $1) is assigned to Factor (that is $$) */
      $$ = $1; }
  ;
   

