%{

// Directives to the compiler and C declarations
#include <stdio.h>
#define YYERROR_VERBOSE 1

// The lexer
extern int yylex();
extern int yyerror(char *);

%}

// Tokens, given by lexer
%token PLUS
%token MINUS
%token PER
%token NUMBER

// Types for tokens and rules
%type <ival> NUMBER
%type <ival> Factor
%type <ival> Term
%type <ival> Expr

// Possible types of yylval
%union {
  int	ival;
}

%%

Eval
  : Expr '='
    { printf("\n%d",$1); 
      YYACCEPT;
    }
  ;

Expr
  : Term PLUS Expr
    { $$ = $1 + $3; }
  | Term MINUS Expr
    { $$ = $1 - $3; }
  | Term
    { $$ = $1;}
  ;

Term
  : Term PER Factor
    { $$ = $1 * $3; }
  | Factor
    { $$ = $1; }
  ;

Factor
  : '(' Expr ')'
    { $$ = $2; }
  | NUMBER
    { $$ = $1; }
  ;
   

