%{
// Directives to the compiler and C declarations
#include <stdio.h>
// If this macro is defined, tha parser passes to the function yyerror, as string, a
// DETAILED description of the occurred error.
#define YYERROR_VERBOSE 1

// Declaration as extern of the function yylex(), that implements the scanner
extern int yylex();
// Declaration as extern of the function yylex(), that implements the scanner
extern int yyerror(char *);

%}

// Symbolic names for the tokens, given by lexer
%token OPENPAR
%token CLOSEPAR
%token NUMBER
%token COMMA

%%

List
  : Par
    { /* An empty action. Specifying an empty action, the parser executes an empty C-code when it matches the rule.
         In this way, it does not execute the default action: please refer to the "reference manual" of Bison to
         a detailed description of 'default action' */ }
  | Par COMMA List
    { }
  ;

Par
  : OPENPAR Par CLOSEPAR 
    { }
  | OPENPAR Par CLOSEPAR Par
    { }
  | NUMBER Par
    { }
  | NUMBER
    { }
  ;
  

