%{
// ex1l.lex

#include <stdlib.h>
#include "proggr.tab.h"

%}

%option noyywrap 

%%

"BEGIN" 	{return bEGIN;}
"END"    	{return END;}
"INT"    	{return INT;}
"FLOAT"  	{return FLOAT;}
"VARDEC"	{return VARDEC;}
"(" 		{return '(';}
")" 		{return ')';}
"," 		{return ',';}
";"		{return ';';}
"+"		{return '+';}
"-"		{return '-';}
"*"		{return '*';}
"="		{return '=';}

"-"?[0-9]|([1-9][0-9]*) {
  /* a number */
  return NUMBER;
}

[a-zA-Z]+ {
  /* An identifier. Remember the rules about the input matching.
     If an input can be matched to two rules, it is matched to the
     first one in list (no confusion among identifiers and types) */
  return IDENTIFIER; 
}
