%{

// Directives to the compiler and C declarations
#include <stdio.h>
#define YYERROR_VERBOSE 1

// The lexer
extern int yylex();
extern int yyerror(char *);

%}

// Tokens, given by the lexer
%token IDENTIFIER
%token NUMBER
%token INT
%token FLOAT
%token bEGIN
%token END
%token VARDEC

%%

Program
  : bEGIN ProgramName Body END ProgramName
    { printf("Matched a Program Definition\n"); }
  ;

Body
  : VarDec ';' StatementList
    { printf("Matched the Program Body\n");}
  ;

VarDec
  : VARDEC VarList
    { printf("Matched Variable Declarations\n");}
  ;

VarList
  : Type NameList
  | Type NameList VarList
  ;

NameList
  : Name
  | Name ',' NameList
  ;

StatementList
  : Statement ';'
  | Statement ';' StatementList
  ;

Statement
  : Assignment
  ;

Assignment
  : Name '=' Expr
    { printf("Matched an Assignment\n"); }
  ;

Expr
  : Term '+' Expr
  | Term '-' Expr
  | Term
  ;

Term
  : Term '*' Factor
  | Factor
  ;

Factor
  : '(' Expr ')'
  | NUMBER
  | Name
  ;

ProgramName
  : IDENTIFIER
  ;

Name
  : IDENTIFIER
  ;

Type
  : INT 
  | FLOAT
  ;

  

