/* syntaxTree.h
 * Data structures and prototypes to handle a very simple syntax tree */

/* The following structures permits to build a Syntax Tree.
 * Each node of the syntax tree is an instance of structure stNode 
 * The last field of stNode is a list of children. Each children is a
 * struct child.
 * The first field of the struct child points to the effective child in the tree,
 * that is an stNode....and so on.
 */

#ifndef ST_H
#define ST_H

typedef struct _stNode{
  char *name;
  int nChildren;
  struct _child *children;
}stNode;

typedef struct _child{
  stNode *to;
  struct _child *next;
}child;

//===============================================================================

/* Creates a new stNode ad updates its field "name" */
stNode *createStNode(char *name);

/* Appends parameter chld as child of parameter parent. */
void appendChild(stNode *parent, stNode *chld);

// recursive Pretty Printing
void recursivePP(stNode *root, int ind);

#endif
